﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Graphics
{
    public partial class FrmGame : Form
    {
        // Ostavljamo namespace kompletni jer 
        // je u koliziji sa imenom projekta
        // Graphics
        System.Drawing.Graphics g;
        Bitmap img;
        Point position;
        List<Point> bombs;

        public FrmGame()
        {
            InitializeComponent();
            img = new Bitmap(pnlGame.Width, pnlGame.Height);
            pnlGame.BackgroundImage = img;
            g = System.Drawing.Graphics.FromImage(img);
            bombs = new List<Point>();

            this.KeyDown += FrmGame_KeyDown;

            timCreateBomb.Start();
            timerMove.Start();

            //Graphics.Properties.Resources.bomb

            position = pbPlayer.Location;
            // position = new Point(pnlGame.Width / 2, pnlGame.Height - 20);
            // DrawPlayer();
        }

        private void FrmGame_KeyDown(object sender, KeyEventArgs e)
        {
            //Rectangle r = new Rectangle(position.X, position.Y, 10, 10);
            //SolidBrush sb = new SolidBrush(Color.White);
            //g.FillEllipse(sb, r);
            //pnlGame.Invalidate(r);
            // g.Clear();

            switch (e.KeyCode)
            {
                case Keys.Up:
                    if (position.Y - 20 > 0)
                    {
                        position.Y = position.Y - 20;
                    }
                    break;
                case Keys.Down:
                    if (position.Y + 20 < pnlGame.Height)
                    {
                        position.Y = position.Y + 20;
                    }
                    break;
                case Keys.Left:
                    if (position.X - 20 > 0)
                    {
                        position.X = position.X - 20;
                    }
                    break;
                case Keys.Right:
                    if (position.X + 20 < pnlGame.Width)
                    {
                        position.X = position.X + 20;
                    }
                    break;
                default:
                    break;
            }
            pbPlayer.Location = position;
            //DrawPlayer();
        }

        private void DrawPlayer()
        {
            Rectangle rect = new Rectangle(position.X, position.Y, 10, 10);
            SolidBrush sb = new SolidBrush(Color.Blue);
            g.FillEllipse(sb, rect);
            pnlGame.Invalidate(rect);
        }

        private void timCreateBomb_Tick(object sender, EventArgs e)
        {
            Random r = new Random();
            Point p = new Point(r.Next(pnlGame.Width), 20);
            bombs.Add(p);
            SolidBrush sb = new SolidBrush(Color.Red);
            Rectangle rect = new Rectangle(p.X, p.Y, 10, 10);
            g.FillEllipse(sb, rect);
            pnlGame.Invalidate(rect);
        }

        private void timerMove_Tick(object sender, EventArgs e)
        {
            for(int i = 0; i < bombs.Count; i++)
            {
                // Uklanjanje stare bombe
                SolidBrush sbWhite = new SolidBrush(Color.White);
                Rectangle rectOld = new Rectangle(bombs[i].X, bombs[i].Y, 10, 10);
                g.FillEllipse(sbWhite, rectOld);

                // Crtanje nove
                Point newPoint = new Point(bombs[i].X, bombs[i].Y + 10);
                bombs[i] = newPoint;
                SolidBrush sbRed = new SolidBrush(Color.Red);
                Rectangle rectNew = new Rectangle(bombs[i].X, bombs[i].Y, 10, 10); ;

                // Da li bomba kaci naseg igraca
                //Rectangle rectPlayer = new Rectangle(position.X, position.Y, 10, 10);
                Rectangle rectPlayer = new Rectangle(pbPlayer.Location.X, pbPlayer.Location.Y, pbPlayer.Width, pbPlayer.Height);
                if (rectNew.IntersectsWith(rectPlayer))
                {
                    timCreateBomb.Stop();
                    timerMove.Stop();
                    MessageBox.Show("Kraj!");
                }

                g.FillEllipse(sbRed, rectNew);
                pnlGame.Invalidate();

            }
        }
    }
}
