﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace TicTacToe
{
    public partial class FrmGame : Form
    {
        bool xPlays = true;
        int[,] mat = new int[3, 3];

        public FrmGame()
        {
            InitializeComponent();

            this.btnGame00.Click += this.ButtonClick;
            this.btnGame01.Click += this.ButtonClick;
            this.btnGame02.Click += this.ButtonClick;
            this.btnGame10.Click += this.ButtonClick;
            this.btnGame11.Click += this.ButtonClick;
            this.btnGame12.Click += this.ButtonClick;
            this.btnGame20.Click += this.ButtonClick;
            this.btnGame21.Click += this.ButtonClick;
            this.btnGame22.Click += this.ButtonClick;
            //this.btnGame00.Click += this.ButtonClick2;
        }

        private void ButtonClick(object sender, EventArgs e)
        {
            Button btn = (Button)sender;
            string[] position = btn.Tag.ToString().Split(',');
            int i = Convert.ToInt32(position[0]);
            int j = Convert.ToInt32(position[1]);
            if (this.xPlays)
            {
                btn.Text = "X";
                this.mat[i, j] = 1;
            }
            else
            {
                btn.Text = "O";
                this.mat[i, j] = 2;
            }
            this.xPlays = !this.xPlays;
            btn.Enabled = false;
            CheckGame();
        }


        private void CheckGame()
        {
            int x = 0; // broj x
            int o = 0; // broj oks

            // po redovima 
            for (int i = 0; i < 3; i++)
            {
                x = o = 0;
                for (int j = 0; j < 3; j++)
                {
                    if (mat[i, j] == 1) x++;
                    if (mat[i, j] == 2) o++;
                }

                if (x == 3)
                {
                    MessageBox.Show("X pobjednik!"); return;
                }

                if (o == 3)
                {
                    MessageBox.Show("O pobjednik!"); return;
                }
            }

            // po kolonama 
            for (int j = 0; j < 3; j++)
            {
                x = o = 0;
                for (int i = 0; i < 3; i++)
                {
                    if (mat[i, j] == 1) x++;
                    if (mat[i, j] == 2) o++;
                }

                if (x == 3)
                {
                    MessageBox.Show("X pobjednik!"); return;
                }

                if (o == 3)
                {
                    MessageBox.Show("O pobjednik!"); return;
                }
            }

            // po glavnoj dijagonali
            x = o = 0;
            for(int i = 0; i < 3; i++)
            {
                if (mat[i, i] == 1) x++;
                if (mat[i, i] == 2) o++;
            }

            if (x == 3)
            {
                MessageBox.Show("X pobjednik!"); return;
            }

            if (o == 3)
            {
                MessageBox.Show("O pobjednik!"); return;
            }

            x = o = 0; 
            for (int i = 0; i < 3; i++)
            {
                if (mat[i, 2 - i] == 1) x++;
                if (mat[i, 2 - i] == 2) o++;
            }

            if (x == 3)
            {
                MessageBox.Show("X pobjednik!"); return;
            }

            if (o == 3)
            {
                MessageBox.Show("O pobjednik!"); return;
            }
        }

        //private void ButtonClick2(object sender, EventArgs e)
        //{
        //    MessageBox.Show("Klik!");
        //}
    }
}
